-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_Rotate3D_Z"

-- **************************************************
-- General information about this script
-- **************************************************

LM_Rotate3D_Z = {}

function LM_Rotate3D_Z:Name()
	return "Rotate 3D Z"
end

function LM_Rotate3D_Z:Version()
	return "5.0"
end

function LM_Rotate3D_Z:Description()
	return "Rotates a 3D model around the Z axis."
end

function LM_Rotate3D_Z:Creator()
	return "Lost Marble"
end

function LM_Rotate3D_Z:UILabel()
	return("Rotate Z")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_Rotate3D_Z:IsEnabled(moho)
	if (moho.layer:LayerType() ~= MOHO.LT_3D) then
		return false
	end
	if (moho.layer:CurrentAction() ~= "") then
		return false -- creating new objects in the middle of an action can lead to unexpected results
	end
	return true
end

function LM_Rotate3D_Z:Run(moho)
	local mesh = moho:Mesh3D()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	local vec = LM.Vector3:new_local()

	for i = 0, mesh:CountPoints() - 1 do
		local v = mesh:Point(i)
		v:Rotate(LM.Z_AXIS, math.rad(90))
		mesh:SetPoint(i, v)
	end

	-- Because we modified the points directly, this mesh shouldn't be re-loaded from an external file.
	-- This can be prevented by telling the layer that there is no external file.
	local layer = moho:LayerAs3D(moho.layer)
	layer:SetSourceMesh("")
end
