-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_HandheldCamera"

-- **************************************************
-- General information about this script
-- **************************************************

LM_HandheldCamera = {}

function LM_HandheldCamera:Name()
	return "Handheld Camera"
end

function LM_HandheldCamera:Version()
	return "5.0"
end

function LM_HandheldCamera:Description()
	return "Simulates a handheld camera by adding the proper amount of noise to the camera's interpolation."
end

function LM_HandheldCamera:Creator()
	return "Lost Marble"
end

function LM_HandheldCamera:UILabel()
	return("Handheld Camera")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_HandheldCamera:Run(moho)
	moho.document:SetDirty()
	moho.document:PrepUndo(moho.layer)

	local ch = moho.document.fCameraTrack
	for id = 0, ch:CountKeys() - 1 do
		ch:SetKeyInterpByID(id, MOHO.INTERP_NOISY, 0.0125, 0.35)
	end

	ch = moho.document.fCameraRoll
	local angle = math.rad(2)
	for id = 0, ch:CountKeys() - 1 do
		ch:SetKeyInterpByID(id, MOHO.INTERP_NOISY, angle, 0.2)
	end

	ch = moho.document.fCameraPanTilt
	local angle = math.rad(2)
	for id = 0, ch:CountKeys() - 1 do
		ch:SetKeyInterpByID(id, MOHO.INTERP_NOISY, angle, 0.2)
	end
end
