-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_DeleteEdge"

-- **************************************************
-- General information about this script
-- **************************************************

LM_DeleteEdge = {}

function LM_DeleteEdge:Name()
	return "Delete Edge"
end

function LM_DeleteEdge:Version()
	return "5.0"
end

function LM_DeleteEdge:Description()
	return "Click on an edge to delete it"
end

function LM_DeleteEdge:Creator()
	return "Lost Marble"
end

function LM_DeleteEdge:UILabel()
	return("Delete Edge")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_DeleteEdge:IsEnabled(moho)
	if (moho:CountEdges() > 0) then
		return true
	end
	return false
end

function LM_DeleteEdge:OnMouseDown(moho, mouseEvent)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	local curveID = -1
	local segID = -1
	curveID, segID = mouseEvent.view:PickEdge(mouseEvent.pt, curveID, segID)
	if (curveID >= 0 and segID >= 0) then -- an edge was clicked on
		mesh:DeleteEdge(curveID, segID, moho.frame)
	end
	mouseEvent.view:DrawMe()
end

function LM_DeleteEdge:OnMouseMoved(moho, mouseEvent)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	local curveID = -1
	local segID = -1
	curveID, segID = mouseEvent.view:PickEdge(mouseEvent.pt, curveID, segID)
	if (curveID >= 0 and segID >= 0) then -- an edge was clicked on
		mesh:DeleteEdge(curveID, segID, moho.frame)
	end
	mouseEvent.view:DrawMe()
end

function LM_DeleteEdge:OnKeyDown(moho, keyEvent)
	LM_SelectPoints:OnKeyDown(moho, keyEvent)
end
