-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_DeleteShape"

-- **************************************************
-- General information about this script
-- **************************************************

LM_DeleteShape = {}

function LM_DeleteShape:Name()
	return "Delete Shape"
end

function LM_DeleteShape:Version()
	return "5.0"
end

function LM_DeleteShape:Description()
	return "Click on a shape to delete it"
end

function LM_DeleteShape:Creator()
	return "Lost Marble"
end

function LM_DeleteShape:UILabel()
	return("Delete Shape")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_DeleteShape:IsEnabled(moho)
	if (moho:CountShapes() > 0) then
		return true
	end
	return false
end

function LM_DeleteShape:OnMouseDown(moho, mouseEvent)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	local id = mouseEvent.view:PickShape(mouseEvent.pt)
	if (id >= 0) then
		mesh:DeleteShape(id)
	end
	mouseEvent.view:DrawMe()
end

function LM_DeleteShape:OnMouseMoved(moho, mouseEvent)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	local id = mouseEvent.view:PickShape(mouseEvent.pt)
	if (id >= 0) then
		mesh:DeleteShape(id)
	end
	mouseEvent.view:DrawMe()
end
