-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_FlipPointsH"

-- **************************************************
-- General information about this script
-- **************************************************

LM_FlipPointsH = {}

function LM_FlipPointsH:Name()
	return "Flip Points H"
end

function LM_FlipPointsH:Version()
	return "5.0"
end

function LM_FlipPointsH:Description()
	return "Flip selected points horizontally"
end

function LM_FlipPointsH:Creator()
	return "Lost Marble"
end

function LM_FlipPointsH:UILabel()
	return("Flip Horizontally")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_FlipPointsH:IsEnabled(moho)
	if (moho:CountSelectedPoints() > 2) then
		return true
	end
	return false
end

function LM_FlipPointsH:Run(moho)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	local center = mesh:SelectedCenter()

	for i = 0, mesh:CountPoints() - 1 do
		local pt = mesh:Point(i)
		if (pt.fSelected) then
			local f = center.x - pt.fPos.x
			pt.fPos.x = center.x + f
		end
	end

	moho:AddPointKeyframe(moho.frame)
	moho:NewKeyframe(CHANNEL_POINT)
end
