-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_FlipPointsV"

-- **************************************************
-- General information about this script
-- **************************************************

LM_FlipPointsV = {}

function LM_FlipPointsV:Name()
	return "Flip Points V"
end

function LM_FlipPointsV:Version()
	return "5.0"
end

function LM_FlipPointsV:Description()
	return "Flip selected points vertically"
end

function LM_FlipPointsV:Creator()
	return "Lost Marble"
end

function LM_FlipPointsV:UILabel()
	return("Flip Vertically")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_FlipPointsV:IsEnabled(moho)
	if (moho:CountSelectedPoints() > 2) then
		return true
	end
	return false
end

function LM_FlipPointsV:Run(moho)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	local center = mesh:SelectedCenter()

	for i = 0, mesh:CountPoints() - 1 do
		local pt = mesh:Point(i)
		if (pt.fSelected) then
			local f = center.y - pt.fPos.y
			pt.fPos.y = center.y + f
		end
	end

	moho:AddPointKeyframe(moho.frame)
	moho:NewKeyframe(CHANNEL_POINT)
end
