-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_LowerShape"

-- **************************************************
-- General information about this script
-- **************************************************

LM_LowerShape = {}

function LM_LowerShape:Name()
	return "Lower Shape"
end

function LM_LowerShape:Version()
	return "5.0"
end

function LM_LowerShape:Description()
	return "Lower the selected shape in the stacking order"
end

function LM_LowerShape:Creator()
	return "Lost Marble"
end

function LM_LowerShape:UILabel()
	return("Lower Shape")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_LowerShape:IsEnabled(moho)
	if (moho:CountSelectedShapes() > 0) then
		return true
	end
	return false
end

function LM_LowerShape:Run(moho)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	for i = 0, mesh:CountShapes() - 1 do
		if (mesh:Shape(i).fSelected) then
			mesh:LowerShape(i, false)
			break
		end
	end
end
