-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_PanW"

-- **************************************************
-- General information about this script
-- **************************************************

LM_PanW = {}

function LM_PanW:Name()
	return "Pan Workspace"
end

function LM_PanW:Version()
	return "5.0"
end

function LM_PanW:Description()
	return "Drag mouse to pan around the workspace"
end

function LM_PanW:Creator()
	return "Lost Marble"
end

function LM_PanW:UILabel()
	return("Pan")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_PanW:OnMouseDown(moho, mouseEvent)
	mouseEvent.view:PanDown(mouseEvent.pt)
end

function LM_PanW:OnMouseMoved(moho, mouseEvent)
	mouseEvent.view:PanMoved(mouseEvent.pt)
end

function LM_PanW:OnMouseUp(moho, mouseEvent)
	mouseEvent.view:PanUp(mouseEvent.pt)
end

-- **************************************************
-- Tool options - create and respond to tool's UI
-- **************************************************

LM_PanW.RESET = MOHO.MSG_BASE

function LM_PanW:DoLayout(moho, layout)
	layout:AddChild(LM.GUI.Button("Reset View", self.RESET))
end

function LM_PanW:HandleMessage(moho, view, msg)
	if (msg == self.RESET) then
		view:ResetView()
	end
end
