-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_Peak"

-- **************************************************
-- General information about this script
-- **************************************************

LM_Peak = {}

function LM_Peak:Name()
	return "Peak"
end

function LM_Peak:Version()
	return "5.0"
end

function LM_Peak:Description()
	return "Peaks curves that pass through the selected points"
end

function LM_Peak:Creator()
	return "Lost Marble"
end

function LM_Peak:UILabel()
	return("Peak")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_Peak:IsEnabled(moho)
	if (moho:CountSelectedPoints() > 0) then
		return true
	end
	return false
end

function LM_Peak:Run(moho)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	for i = 0, mesh:CountPoints() - 1 do
		local pt = mesh:Point(i)
		if (pt.fSelected) then
			pt:SetCurvature(MOHO.PEAKED, moho.frame)
		end
	end
	moho:NewKeyframe(CHANNEL_CURVE)
end
