-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_RaiseShape"

-- **************************************************
-- General information about this script
-- **************************************************

LM_RaiseShape = {}

function LM_RaiseShape:Name()
	return "Raise Shape"
end

function LM_RaiseShape:Version()
	return "5.0"
end

function LM_RaiseShape:Description()
	return "Raise the selected shape in the stacking order"
end

function LM_RaiseShape:Creator()
	return "Lost Marble"
end

function LM_RaiseShape:UILabel()
	return("Raise Shape")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_RaiseShape:IsEnabled(moho)
	if (moho:CountSelectedShapes() > 0) then
		return true
	end
	return false
end

function LM_RaiseShape:Run(moho)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	for i = 0, mesh:CountShapes() - 1 do
		if (mesh:Shape(i).fSelected) then
			mesh:RaiseShape(i, false)
			break
		end
	end
end
