-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_RotateW"

-- **************************************************
-- General information about this script
-- **************************************************

LM_RotateW = {}

function LM_RotateW:Name()
	return "Rotate Workspace"
end

function LM_RotateW:Version()
	return "5.0"
end

function LM_RotateW:Description()
	return "Drag mouse to rotate the workspace (hold <shift> to constrain)"
end

function LM_RotateW:Creator()
	return "Lost Marble"
end

function LM_RotateW:UILabel()
	return("Rotate")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_RotateW:OnMouseDown(moho, mouseEvent)
	mouseEvent.view:RotateDown(mouseEvent.pt)
end

function LM_RotateW:OnMouseMoved(moho, mouseEvent)
	mouseEvent.view:RotateMoved(mouseEvent.pt)
end

function LM_RotateW:OnMouseUp(moho, mouseEvent)
	mouseEvent.view:RotateUp(mouseEvent.pt)
end

-- **************************************************
-- Tool options - create and respond to tool's UI
-- **************************************************

LM_RotateW.RESET = MOHO.MSG_BASE

function LM_RotateW:DoLayout(moho, layout)
	layout:AddChild(LM.GUI.Button("Reset View", self.RESET))
end

function LM_RotateW:HandleMessage(moho, view, msg)
	if (msg == self.RESET) then
		view:ResetView()
	end
end
