-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_Smooth"

-- **************************************************
-- General information about this script
-- **************************************************

LM_Smooth = {}

function LM_Smooth:Name()
	return "Smooth"
end

function LM_Smooth:Version()
	return "5.0"
end

function LM_Smooth:Description()
	return "Smoothes curves that pass through the selected points"
end

function LM_Smooth:Creator()
	return "Lost Marble"
end

function LM_Smooth:UILabel()
	return("Smooth")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_Smooth:IsEnabled(moho)
	if (moho:CountSelectedPoints() > 0) then
		return true
	end
	return false
end

function LM_Smooth:Run(moho)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

	for i = 0, mesh:CountPoints() - 1 do
		local pt = mesh:Point(i)
		if (pt.fSelected) then
			pt:SetCurvature(MOHO.SMOOTH, moho.frame)
		end
	end
	moho:NewKeyframe(CHANNEL_CURVE)
end
