-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "LM_ZoomW"

-- **************************************************
-- General information about this script
-- **************************************************

LM_ZoomW = {}

function LM_ZoomW:Name()
	return "Zoom Workspace"
end

function LM_ZoomW:Version()
	return "5.0"
end

function LM_ZoomW:Description()
	return "Drag mouse to zoom the workspace"
end

function LM_ZoomW:Creator()
	return "Lost Marble"
end

function LM_ZoomW:UILabel()
	return("Zoom")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function LM_ZoomW:OnMouseDown(moho, mouseEvent)
	mouseEvent.view:ZoomDown(mouseEvent.pt)
end

function LM_ZoomW:OnMouseMoved(moho, mouseEvent)
	mouseEvent.view:ZoomMoved(mouseEvent.pt)
end

function LM_ZoomW:OnMouseUp(moho, mouseEvent)
	mouseEvent.view:ZoomUp(mouseEvent.pt)
end

-- **************************************************
-- Tool options - create and respond to tool's UI
-- **************************************************

LM_ZoomW.RESET = MOHO.MSG_BASE

function LM_ZoomW:DoLayout(moho, layout)
	layout:AddChild(LM.GUI.Button("Reset View", self.RESET))
end

function LM_ZoomW:HandleMessage(moho, view, msg)
	if (msg == self.RESET) then
		view:ResetView()
	end
end
